/* "$Id: CalendarP.h,v 1.10 2005/06/09 10:02:15 jjf Exp $" */

/*
  This file is part of xdeskcal.
  Copyright  2005 J Farlow, jjf1125@earthlink.net.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* 
   The design of the transparent calendar widget is derived from the 
   Eyes widget in xeyes.
*/

#include <X11/CoreP.h>

typedef struct _day {
  int day_no;
  int month_no;
  int year_no;
  int x;
  int y;
  int width;
  int height;
} Day;

typedef struct _wday {
  char name[2];
  int x;
  int y;
  int width;
  int height;
} WDay;

typedef struct _CalendarPart {
  /* Resources */
  char         *font;             /* Font name.                        */
  Boolean      shape_window;      /* Whether to use Shape Extension.   */
  char         *fg;               /* Foreground color name.            */
                                  /* Unless user specified:            */
  int          month;             /*  localtime()->tm_mon + 1 (1-12).  */
  int          year;              /*  localtime()->tm_year + 1900.     */
  Boolean      nohighlight;       /* Don't highlight today's date.     */
  /* Private Data */
  Boolean      update;            /* True if no month or year          */
                                  /*  given as an option.              */
  int          date;              /* Today's date.                     */
  char         *default_font;     /* Fixed font.                       */
  Font         font_info;         /* Font information from X server.   */
  XFontStruct  *font_struct;      /* Font data.                        */
  Pixel        fgp;               /* Foreground and background pixels. */
  Pixel        bgp;
  WDay         wdays[7];          /* Calendar data.                    */
  Day          days[5][7];
} CalendarPart;

typedef struct _CalendarRec {
  CorePart core;
  CalendarPart calendar;
   } CalendarRec;

typedef struct { int dummy; } CalendarClassPart;

typedef struct _CalendarClassRec {
   CoreClassPart core_class;
   CalendarClassPart calendar_class;
   } CalendarClassRec;

extern CalendarClassRec calendarClassRec;

WidgetClass calendarWidgetClass = (WidgetClass) &calendarClassRec;


